{****************************************************************************}
{                                                                            }
{ ਠ 1.23   ࠯ ⮤          . ##-###       ... }
{                                                                            }
{           P^2                                     P = 50-200 [],         }
{   f(w) = ----- * ( 1 + Q^2 * (2*dw/wp))^(-1/2),   Rn= 0.1-5  [],         }
{           Rn                                      Q = 50-1000,             }
{                                                   wp-  १,   }
{                                                   dw- 蠣,                 }
{                                                                            }
{****************************************************************************}

{                              பᨬ
      பᨬ樥   뢠       ⥬᪨  ꥪ⮢
   (ᥫ, 㭪権)  㣨,    묨   ⮬      ᫥  
     室.
        襭     பᨬ樨  ।,     
   筥  பᨬ㥬  㭪樨  f(x)  ( ᯥ६⠫쭮 
   ⠭  㫥)    㧫  窠  (筮  뢠  㧫
   ௮樨) X1, X2, ..., Xn.  室  㭪 P(x),  
   ன   뫮  ।  祭 室 㭪樨   㣨
   (⫨  㧫)  祭 㬥  x   ன 筮 
   譮.
         பᨬ樨: ௮  ࠯.
      ௮  -   ᪠ ஬  祭 㭪樨 
    ࢠ [X1, X]   祭  x   ᮢ  㧫묨
   窠.
      ࠯ -  ࠭ 뢮, 祭  
            ,      ।
   祭 㭪樨   ࢠ [X, X]. }



PROGRAM GIR;

{$N-}

USES Crt;



CONST
   Max_kol = 25;                       {ᨬ쭮 ⢮ 㧫}
   Tochka  = 10;                       {⢮  ᫥ ⮩}



TYPE
   _Real = Real;
   _INTEGER = Byte;
   _Mas = array [1..Max_kol] of _Real;




VAR
   H, F_up, F_down, eps_pol, eps_tek   : _Real;
   Xpol, Ypol, V                       : _Mas;
   n, m                                : _INTEGER;     {n-⢮ 㧫}
   Pr                                  : Char;         {४⥫}


{----------------------------------------------------------------------------}


{ ⠡    㭪樨}
PROCEDURE TABL_FUNC(Var Xpol, Ypol: _Mas; Var n: _INTEGER; Var dw, eps_pol: _Real);
VAR
   P, Rn, Q, wp, wn   : _Real;
   I                  : _INTEGER;            {稪}

BEGIN
   Write('⨢ P ............. = '); ReadLn(P);
   Write('⨢ 㧪 Rn ... = '); ReadLn(Rn);
   Write('ࠬ Q .................. = '); ReadLn(Q);
   Write('砫쭠  wp ......... = '); ReadLn(wn);
   Write('   dw .... = '); ReadLn(dw);
   Write('⢮ 㧫 (< ', Max_kol:2, ') ..... = '); ReadLn(n);
   Write('筮 eps_pol ............ = '); ReadLn(eps_pol);
   WriteLn;


  { 㭪樨  㧫}
   wp:= wn;
   FOR I:= 1 TO (n+1) DO
    begin
       Xpol[I]:= wp;
       Ypol[I]:= Sqr(P) / (Rn * Sqrt(1 + Sqr(Q) * Sqr(2*dw/wp)));
       wp:= wp + dw;
    end;
END;

{--------------------------<   TABL_FUNC >----------------------------}



{ 祭 பᨬ㥬 㭪樨}
PROCEDURE VVOD_TABL(Var Xpol, Ypol: _Mas; Var n: _INTEGER; Var dw, eps_pol: _Real);
VAR
   wp, wn   : _Real;
   I        : _INTEGER;                      {稪}

BEGIN
   Write('砫 㧥 ............ = '); ReadLn(wn);
   Write('  㧫 ........ = '); ReadLn(dw);
   Write('⢮ 㧫 (< ', Max_kol:2, ') ... = '); ReadLn(n);
   Write('譮 eps .............. = '); ReadLn(eps_pol);
   WriteLn;

  { 祭 㭪樨  㧫}
   WriteLn('   祭 㭪樨  㧫:');
   wp:= wn;
   FOR I:= 1 TO n DO
    begin
       Xpol[I]:= wp;
       Write('Y(', wp:Tochka, ')= '); ReadLn(Ypol[I]);
       wp:= wp + dw;
    end;

  { (n+1)-㧫}
   Xpol[n+1]:= wp;
END;

{---------------------------<   VVOD_TABL >---------------------------}



{ 樥⮢ }
PROCEDURE Kff_pol(X: _Mas; H: _Real; n, m: _INTEGER; Var V: _Mas);

TYPE
   _Matric = array [1..Max_kol] of _Mas;
   _Vector = array [1..Max_kol] of Byte;

VAR
   G      : _Matric;
   P      : _Vector;
   I, J   : _INTEGER;                        {稪}

{----------------------------------------------------------------------------}

{襭 筮 ⥬ ࠢ, ⮤ "LU-ࠧ"}
PROCEDURE GVP(G: _Matric; P: _Vector; m: _INTEGER; Var V: _Mas);
VAR
   K, I, J   : _INTEGER;                         {稪}
   L, U      : _Matric;                          {ᯮ⥫ }
   SOS       : _Mas;                             {ᯮ⥫ }
   alf, S    : _Real;                            {ᯮ⥫ ६}

BEGIN
  {㫥 ⮢ ᯮ⥫  L  U}
   FOR I:= 1 TO m DO
   For J:= 1 To m Do
    begin
       L[I, J]:= 0;                              { L[I, J] = 0,  I=1..m, J=1..m   }
       U[I, J]:= 0;                              { U[I, J] = 0,  I=1..m, J=1..m   }
    end;


    {ࠧ  G   L  U}
     FOR K:= 1 TO m DO
      begin
        {ନ஢  L}
         For I:= K To m Do
          begin
            { 㬬 ⮢  S}
             S:= 0;
             for J:= 1 to (K - 1) do
              begin                              {    k-1                                      }
                 alf:= L[I, J] * U[J, K];        { S = E (L[I, J] * U[J, K]),                  }
                 S:= S + alf;                    {    j=1                                      }
              end;

             L[I, K]:= G[I, K] - S;              { L[I, K] = G[I, K] - S,  k=1..m, i=k..m   }
          end;

        {ନ஢  U}
         U[K, K]:= 1;
         For I:= (K + 1) To m Do
          begin
            { 㬬 ⮢  S}
             S:= 0;
             for J:= 1 to (K - 1) do
              begin                              {    k-1                                             }
                 alf:= L[K, J] * U[J, I];        { S = E (L[K, J] * U[J, I]),                         }
                 S:= S + alf;                    {    j=1                                             }
              end;
                                                 {            G[I, K] - S                                           }
             alf:= G[I, K] - S;                  { U[K, I] = -------------,   k=1..m, i=(k+1)..m   }
             U[K, I]:= alf/L[K, K];              {              L[K, K]                                             }
          end;
      end;


    {᫥ ᯮ⥫쭮  SOS}
     FOR K:= 1 TO m DO
      begin
        { 㬬 ⮢  S}
         S:= 0;
         For I:= 1 To (K - 1) Do
          begin                                  {    k-1                            }
             alf:= L[K, I] * SOS[I];             { S = E (L[K, I] * SOS[I]),         }
             S:= S + alf;                        {    i=1                            }
          end;
                                                 {           P[K] - S                }
         alf:= P[K] - S;                         { SOS[K] = ----------,  k=1..m   }
         SOS[K]:= alf/L[K, K];                   {            L[K, K]                }
      end;


    {᫥  V}
     FOR K:= m DOWNTO 1 DO
      begin
        { 㬬 ⮢  S}
         S:= 0;
         For I:= (K + 1) To m Do
          begin                                  {       m                         }
             alf:= U[K, I] * V[I];               { S =   E  (U[K, I] * V[I]),      }
             S:= S + alf;                        {     i=k+1                       }
          end;

         V[K]:= SOS[K] - S;                      { V[K] = SOS[K] - S,  k=1..m   }
      end;
  END;

{------------------------------<   GVP >------------------------------}


BEGIN
 {ନ஢  G}
  FOR I:= 1 TO m DO                                        {           | X[n+1] - X[n - (m-1)] | (m-1)   }
   For J:= 1 To m Do                                       { G[I, J] = |-----------------------|         }
   G[I, J]:= exp( (I-1)*Ln((X[n+1] - X[n-(J-1)]) / H) );   {           |            H          |         }

 {ନ஢  P = [1, 0, 0, 0, ..., 0]}
  P[1]:= 1;
  FOR I:= 2 TO m DO P[I]:= 0;

 {饭   GVP}
  GVP(G, P, m, V);
END;

{---------------------------<   Kff_pol >-----------------------------}



{ }
FUNCTION F_pol(V, Y: _Mas; n, m: _INTEGER): _Real;
VAR
   I: _INTEGER;                              {稪}
   S: _Real;                                 {㬬}

BEGIN
   S:= 0;
   FOR I:= 1 TO m DO S:= S + V[I]*Y[n+1-I];
   F_pol:= S;
END;

{-----------------------------<   F_pol >-----------------------------}



{뢮 祭 㭪樨  (n+1) 㧫}
PROCEDURE VIVOD1(Xpol, Ypol, eps_tek: _Real; n, m: _INTEGER);
BEGIN
   WriteLn;
   WriteLn;
   WriteLn('祭 㭪樨  (n+1) 㧫:  Y(', Xpol:Tochka, ')=', Ypol:Tochka);
   WriteLn('⢮ ᯮ㥬 㧫', m:3, ' ', n:3);
   WriteLn('譮  =', eps_tek:Tochka);
END;

{-----------------------------<   VIVOD1 >----------------------------}



{뢮 祭 㭪樨  (n+1) 㧫  ⮢ 㭪樨}
PROCEDURE VIVOD2(Xpol, Ypol, eps_tek, Y: _Real; n, m: _INTEGER);
VAR
   eps: _Real;

BEGIN                                            {               Y_ - Y_筮  }
   eps:= Abs((Ypol - Y)/Y);                      { EPS_筮 = ---------------------- }
                                                 {                     Y_筮        }
   WriteLn;
   WriteLn('  祭 㭪樨  㧫 X(n+1)=', Xpol:Tochka , ' :');
   WriteLn('Y  ... =', Ypol:Tochka);
   WriteLn('Y 筮 ..... =', Y:Tochka);
   WriteLn('  譮  :');
   WriteLn('⥪ ...... =', eps_tek:Tochka);
   WriteLn('筠 ....... =', eps:Tochka);
   WriteLn;
   WriteLn('⢮ ᯮ㥬 㧫', m:3, ' ', n:3);
END;

{-----------------------------<   VIVOD2 >----------------------------}



{᭮  ணࠬ}
BEGIN
   ClrScr;
   WriteLn('  ExtraPol_GIRA 1.00          Copyright (c) 1999-00                      DGur.');
   WriteLn;
   WriteLn;

  { 室 }
   Write('⮢ ? [Y/N]'); ReadLn(Pr);
   WriteLn;


  { 祭 㭪樨  㧫}
   IF (UpCase(Pr) = 'Y')
     {饭   TABL_FUNC}
      THEN TABL_FUNC(Xpol, Ypol, n, H, eps_pol)
     {饭   VVOD_TABL}
      ELSE VVOD_TABL(Xpol, Ypol, n, H, eps_pol);


  {樮 }
   m:= 2;
   F_down:= 0;
   REPEAT
     {饭   Kff_pol}
      Kff_pol(Xpol, H, n, m, V);

     {饭   F_pol}
      F_up:= F_pol(V, Ypol, n, m);

     {筮 }
      IF Not(F_up = 0) THEN eps_tek:= Abs((F_up - F_down)/F_up);

      F_down:= F_up;

      Inc(m);
   UNTIL (eps_tek < eps_pol) or (m > n);


  {뢮 祭 १⮢}
   IF (UpCase(Pr) = 'Y')
     {饭   VIVOD2}
      THEN VIVOD2(Xpol[n+1], F_up, eps_tek, Ypol[n+1], n, (m-1))
     {饭   VIVOD1}
      ELSE VIVOD1(Xpol[n+1], F_up, eps_tek, n, (m-1));

   ReadKey;
END.                                             { ᭮ }
